Description

This patch adds "watchers" = every issue can be watched by anybody in the project. Every time the issue is

changed, the assigned_to user and all watchers get an email.

To add yourself as a watcher, view an issue, there is a new link and icon next to the edit link and icon:

watch    -> add yourself as a watcher

 unwatch  -> remove yourself as from watchers of this issue.

 I also added a list of all watchers at the bottom of the issue page (show action) - users, that can add members to the

project can add or remove watchers from an issue.

What is missing: tests - I did test it thoroughly, but I haven't added any tests yet :-(. I will, I promise.

Code review - I don't pretend to understand redmine very well - I tried to do it as good as I could, but if something

is inconsistent or bad, please let me know! I will improve the code if I know how.

muro

History

#1 - 2007-03-29 09:38 - Pavol Murin

I'm sorry, I missed one change. Here is the tiny additional

change.

#2 - 2007-04-04 08:14 - Brenden Grace

The only thing I would add is that it is nice to be able to sometimes

include people who may not be aware that they should be included.

They may not even be RedMine users. In bugzilla I would regularly

CC managers or ever sales people so that they could keep up to

date on an issue. Just a suggestion.

#3 - 2007-04-04 08:21 - Pavol Murin

Oh, but that is already included - everybody, who is

autorized to add members to the project can add or remove

other watchers - just scroll to the bottom of the "show

issue" page!

I didn't want everybody to add watchers - but if I can

change my mind :-)

muro

#4 - 2007-04-21 08:16 - Jean-Philippe Lang

I've just added watching functionality.

For now, it's not possible:

- to add someone else

- to view the list of watchers

It will come asap.

I used a different approach (dedicated model and controller)

to allow other things to be watched in the future (eg. forums,

document, wiki page...).
#5 - 2007-04-22 13:27 - Pavol Murin

Thanks, you are right - it is certainly better to allow watching

of forums,

documents etc.

I really like the icon, would it be possible to have a holow

one for one of the

states (e.g. hollow star = issue is not being watched)

Thanks a lot, muro

#6 - 2007-04-22 16:03 - Jean-Philippe Lang

I made a grey scale icon. Hope you'll like :-)

#7 - 2007-04-23 01:39 - Pavol Murin

sounds good! I'll take a look when it's commited into svn (hint,

hint) :-)

muro

#8 - 2007-04-23 15:57 - Jean-Philippe Lang

It took me some time to understand :-)

#9 - 2007-04-23 16:06 - Pavol Murin

Sorry for the cryptic comment :-). Thanks, I like the new icon.

And thanks for the

commited code - I'm not a rails nor ruby expert and it's

an interesting solution.

So I learned something new today. Thanks, Jean Philippe.

muro

#10 - 2007-04-24 09:49 - Pavol Murin

Oh, I just found one more problem - but this might be my

misunderstanding - I would like to let a user know, that an

issue was just assigned to him. I did this in

app/models/mailer.rb, after line 34:

@recipients.push  issue.assigned_to.mail if

issue.assigned_to && !issue.assigned_to.mail.empty?

    @recipients.uniq!

 Another thing: I had a check before line 31:

return unless journal

I'm not sure if it is necessary.

#11 - 2007-04-24 10:07 - Jean-Philippe Lang

In trunk source, all of the project members are receiving the

notifications. So adding the assign user is not necessary.

I know it could be better. I'll try to make mail notifications

more configurable for people, so they can choose what kind of

notifications they receive.

For the second point, did you ever get a nil error

in Mailer#issue_edit ?

#12 - 2007-04-24 10:23 - Pavol Murin

I understand your point. However - we already have hundreds

of issues and getting a mail notification for each change

too much. Most people have mail notifications turned off

(except for one or two people) and only want to receive

notifications if something changes with an issue assigned to

them. That's the reason for the proposed change.

regarding the nil error: you are right - it is probably just

a leftover from development while I was implementing the

feature.

2024-04-30 2/3



Thanks, muro

#13 - 2009-01-09 22:30 - Jean-Philippe Lang

- Status changed from New to Closed

Feature available.

Files

watchers_correction.diff 595 Bytes 2008-02-03 Pavol Murin

watchers.zip 3.04 KB 2008-02-03 Pavol Murin
